Enumerator.product called with keyword arguments raises exception with not precise message
08/03/2023 10:45 AM - andrykonchin (Andrew Konchin)

Status: Closed
Priority: Normal
Assignee:

Target version:

ruby -v: 3.2.1 Backport: 3.0: UNKNOWN, 3.1: UNKNOWN, 3.2:
UNKNOWN

Description

The Enumerator.product method, added in Ruby 3.2, when it's called with keyword arguments (but it expects only a list of enums)
raises unknown keyword: ... (ArgumentError) exception:

Enumerator.product ([], a: 1)
# (irb):1:in “product': unknown keyword: :a (ArgumentError)

But AFAIK unknown keyword is used when a method expects keyword arguments and some not supported keyword arguments were
passed. So | would expect raising exception with no keywords accepted (ArgumentError) message instead that states clearly that no
keywords should be passed.

History

#1 - 08/18/2023 03:58 AM - jeremyevans0 (Jeremy Evans)

| submitted a pull request to fix this, by adding an rb_no_keywords_accepted C-API function and using that for both C methods and Ruby methods
that do not accept keywords: https://github.com/ruby/ruby/pull/8243

#2 - 08/24/2023 09:07 AM - matz (Yukihiro Matsumoto)
- Status changed from Open to Closed

| see no benefit from the proposed change, other than you cannot tell the method takes any keyword argument or not at all from the error message.
In that case, | advise reading the document.

Matz.
